import es, os, playerlib, popuplib, path, random, services

map_file = es.ServerVar("eventscripts_currentmap")
addonDir = path.path(es.getAddonPath('deathmatch'))
script = __name__.rsplit('.',1)[0].replace('.', '/')

def load():
    spawnpoints_path = addonDir.joinpath('spawnpoints/maps/%s.txt' % map_file)
    if not es.exists("command", "Spawnpoints_add"):  
        es.regcmd("Spawnpoints_add", "%s/Spawnpoints_add" % script)
    if not es.exists("command", "!spawnpoints"):
        es.regsaycmd("!spawnpoints", "%s/popup" % script)
    if not es.exists("command", "Spawnpoints_delall"):
        es.regcmd("Spawnpoints_delall", "%s/Spawnpoints_delall" % script)
    loadSpawnpoints(spawnpoints_path)
    spawnmenu = popuplib.create('spawnmenu')
    spawnmenu.addline('Spawnpoints')
    spawnmenu.addline('----------------------')
    spawnmenu.addline('->1. Add My Current Location')
    spawnmenu.addline('----------------------')
    spawnmenu.menuselect = spawnmenu_menuselect
    setup_auth()

'''
    if not es.exists("command", "Spawnpoints_del"):
        es.regcmd("Spawnpoints_del", "spawnpoints/menuSend")
'''


def unload():
    if es.exists('saycommand', 'Spawnpoints_add'):
        es.unregcmd('Spawnpoints_add')
    if es.exists('saycommand', 'Spawnpoints_addmylocation'):
        es.unregcmd('Spawnpoints_addmylocation')
    if es.exists('saycommand', 'Spawnpoints_delall'):
        es.unregcmd('Spawnpoints_delall')
'''
    if es.exists('saycommand', 'Spawnpoints_del'):
        es.unregcmd('Spawnpoints_del')
'''

def es_map_start(ev):
    spawnpoints_path = addonDir.joinpath('spawnpoints/maps/%s.txt' % map_file)
    loadSpawnpoints(spawnpoints_path)

def loadSpawnpoints(spawnpoints_path):
    global location
    if not map_file == "":
        if spawnpoints_path.isfile():
            fileHandle = open(spawnpoints_path, 'r')
            spawnpoints_list= [x.strip() for x in fileHandle.readlines()]
            fileHandle.close()
            location = [x.split(' ', 6) for x in spawnpoints_list]
    else:
        spawnpoints_path.touch()

def round_start(ev):
    userid = es.getuserid()
    if userid:
        ent_setup(userid)

def Spawnpoints_add():
    if es.getargc() >= 4:
        map_file = es.getargv(1)
        if es.getargc() >= 5 and es.getargc() <= 8:
            x = es.getargv(2)
            y = es.getargv(3)
            z = es.getargv(4)
            es.msg(x)
            es.msg(y)
            es.msg(z)
            spawnpoint = " ".join((x, y, z))
            es.msg(spawnpoint)
            if es.getargc() >= 7:
                p = es.getargv(5)
                y = es.getargv(6)
                if es.getargc() == 8:
                    r = es.getargv(7)
                    spawnpoint += " " + " ".join((p, y, r))
                else:
                    spawnpoint += " %s %s 0.000000" % (p, y)
            writetofile(map_file, spawnpoint)
    else:
        es.dbgmsg(0, "Invalid Syntax: Spawnpoints_add <map> <x> <y> <z> [pitch] [yaw] [roll]")

def Spawnpoints_delall():    
    if os.path.isfile(spawnpoints_path):
        os.remove(spawnpoints_path)
    else:
        es.dbgmsg(0, "No such Spawnpoint file exists")

def spawnmenu_menuselect (userid, choice, popupid):
    if choice == 1:
        myLocation = es.getplayerprop(userid, "CBaseEntity.m_vecOrigin").split(",")
        pitch = es.ServerVar("pitch", 0)
        yaw = es.ServerVar("yaw", 0)
        roll = es.ServerVar("roll", 0)
        es.server.queuecmd("est_getviewangle %s pitch yaw roll" % userid)
        spawnpoint = "%s %s %s %s %s %s" % (myLocation[0], myLocation[1], myLocation[2], pitch, yaw, roll)
        writetofile(map_file, spawnpoint)
        es.tell(userid, '#multi', '#greenSpawnpoint #lightgreen%s#green was Created ' % spawnpoint)

def setup_auth():
    global isAuthed
    if services.isRegistered('auth'):
        auth_service = services.use('auth')
        auth_service.registerCapability('spawnpoints_admin', auth_service.ADMIN)
        isAuthed = lambda x: auth_service.isUseridAuthorized(x, 'spawnpoints_admin')
    else:
        isAuthed = lambda x: False

def popup():
    userid = es.getcmduserid()
    if isAuthed(userid):
        popuplib.send('spawnmenu', userid)

def writetofile(map_file, spawnpoint):
    mapFile = addonDir.joinpath('spawnpoints/maps/%s.txt' % map_file)
    file = open(mapFile, "a")
    file.write(spawnpoint + "\n")
    file.close()

def ent_setup(userid):
    if location != []:
        for entity in es.createentitylist('info_player_terrorist'):
            es.server.queuecmd('es_xremove %s' % entity)
        for entity in es.createentitylist('info_player_counterterrorist'):
            es.server.queuecmd('es_xremove %s' % entity)
        for spawn in location:
            for team in ('info_player_terrorist', 'info_player_counterterrorist'):
                es.server.cmd('es_xgive %s %s' % (userid, team))
                index = int(es.ServerVar('eventscripts_lastgive'))
                es.setindexprop(index, 'CBaseEntity.m_vecOrigin', '%s,%s,%s' % (spawn[0], spawn[1], spawn[2]))
                es.setindexprop(index, 'CBaseEntity.m_angRotation', '%s,%s,%s' % (spawn[3], spawn[4], spawn[5]))